#ifndef UART_H_
#define UART_H_

#include <nrf52.h>
#include <nrf52_bitfields.h>
#include "gpio.h"

#define UART_BAUDRATE_1200 			UART_BAUDRATE_BAUDRATE_Baud1200
#define UART_BAUDRATE_2400		  UART_BAUDRATE_BAUDRATE_Baud2400
#define UART_BAUDRATE_4800			UART_BAUDRATE_BAUDRATE_Baud4800 
#define UART_BAUDRATE_9600		  UART_BAUDRATE_BAUDRATE_Baud9600 
#define UART_BAUDRATE_14400		  UART_BAUDRATE_BAUDRATE_Baud14400
#define UART_BAUDRATE_19200		  UART_BAUDRATE_BAUDRATE_Baud19200 
#define UART_BAUDRATE_28800		  UART_BAUDRATE_BAUDRATE_Baud28800
#define UART_BAUDRATE_31250			UART_BAUDRATE_BAUDRATE_Baud31250 
#define UART_BAUDRATE_38400			UART_BAUDRATE_BAUDRATE_Baud38400
#define UART_BAUDRATE_56000			UART_BAUDRATE_BAUDRATE_Baud56000 
#define UART_BAUDRATE_57600		  UART_BAUDRATE_BAUDRATE_Baud57600
#define UART_BAUDRATE_76800			UART_BAUDRATE_BAUDRATE_Baud76800
#define UART_BAUDRATE_115200    UART_BAUDRATE_BAUDRATE_Baud115200
#define UART_BAUDRATE_230400		UART_BAUDRATE_BAUDRATE_Baud230400
#define UART_BAUDRATE_250000 		UART_BAUDRATE_BAUDRATE_Baud250000 
#define UART_BAUDRATE_460800	  UART_BAUDRATE_BAUDRATE_Baud460800 
#define UART_BAUDRATE_921600 	  UART_BAUDRATE_BAUDRATE_Baud921600 
#define UART_BAUDRATE_1000000   UART_BAUDRATE_BAUDRATE_Baud1M


#define UART_TX_PIN_DEFAULT 	  NRF52832_GPIO_PIN8 
#define UART_RX_PIN_DEFAULT			NRF52832_GPIO_PIN9 
#define UART_BAUDRATE_DEFAULT   UART_BAUDRATE_921600   


void init_UART(uint32_t baudrate, uint8_t tx_pin, uint8_t rx_pin);
void putchar_UART(uint8_t data);

#endif
